# Simudo

*SIMUlation of Devices with Optics / SIMulateur Université D'Ottawa*

Simudo is a free open source Poisson/drift-diffusion steady state device model for semiconductor and intermediate band materials, including self-consistent optical absorption and generation.

A description of Simudo's physics and operation can be found in the following publication:

> E. C. Dumitrescu, M. M. Wilkins, and J. J. Krich, Journal of Computational Electronics (2020)
> https://doi.org/10.1007/s10825-019-01414-3

**[Setup instructions](https://static.ecd.space/x/simudo-doc/user/install.html)** to get Simudo up and running on your system.

**[Tutorial](https://static.ecd.space/x/simudo-doc/user/tutorial.html)** containing a small self-contained code example that you can run.

**[API documentation](https://static.ecd.space/x/simudo-doc/apidoc/simudo.html#organization)** to learn more about using Simudo.
